"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from datetime import datetime
from enum import Enum
from exfunc_sdk.types import BaseModel
from typing import Optional
from typing_extensions import NotRequired, TypedDict


class RequestTypedDict(TypedDict):
    url: NotRequired[str]
    r"""The URL to start navigating from"""
    objective: NotRequired[str]
    r"""The natural language objective of the navigation"""


class Request(BaseModel):
    url: Optional[str] = None
    r"""The URL to start navigating from"""

    objective: Optional[str] = None
    r"""The natural language objective of the navigation"""


class ResponseTypedDict(TypedDict):
    page_img: NotRequired[str]
    r"""The base64-encoded string for screenshot of the page that the navigator reached"""
    page_html: NotRequired[str]
    r"""The HTML string of the page that the navigator reached"""


class Response(BaseModel):
    page_img: Optional[str] = None
    r"""The base64-encoded string for screenshot of the page that the navigator reached"""

    page_html: Optional[str] = None
    r"""The HTML string of the page that the navigator reached"""


class Status(str, Enum):
    r"""The status of the navigator task"""

    PENDING = "PENDING"
    IN_PROGRESS = "IN_PROGRESS"
    SUCCEEDED = "SUCCEEDED"
    FAILED = "FAILED"
    TIMED_OUT = "TIMED_OUT"


class NavigatorTaskTypedDict(TypedDict):
    task_id: NotRequired[str]
    r"""The ID of the navigator task"""
    request: NotRequired[RequestTypedDict]
    response: NotRequired[ResponseTypedDict]
    status: NotRequired[Status]
    r"""The status of the navigator task"""
    start_time: NotRequired[datetime]
    r"""The start time of the navigator task"""
    end_time: NotRequired[datetime]
    r"""The end time of the navigator task"""
    last_updated_time: NotRequired[datetime]
    r"""The last updated time of the navigator task"""


class NavigatorTask(BaseModel):
    task_id: Optional[str] = None
    r"""The ID of the navigator task"""

    request: Optional[Request] = None

    response: Optional[Response] = None

    status: Optional[Status] = None
    r"""The status of the navigator task"""

    start_time: Optional[datetime] = None
    r"""The start time of the navigator task"""

    end_time: Optional[datetime] = None
    r"""The end time of the navigator task"""

    last_updated_time: Optional[datetime] = None
    r"""The last updated time of the navigator task"""
